<template>

  <v-dialog
    max-width="620" v-model="dialogo"
    transition="fab-transition" persistent
  >

    <v-card style="border-radius: 10px;" class="pa-6" elevation="0" outlined>

      <v-toolbar elevation="0" color="transparent" dense>

        <v-spacer />
        <v-toolbar-title class="text-h5"> {{ profesor.idProfesor > 0 ? 'Editar' : 'Nuevo' }} Profesor</v-toolbar-title>
        <v-spacer />
        <v-btn icon @click.stop="CerrarDialogo">
          <v-icon size="30"> mdi-close </v-icon>
        </v-btn>

      </v-toolbar>

      <v-card-text class="pa-4">

        <v-form ref="frmProfesor">

          <v-text-field
            name="Profesor-text" label="Nombre" v-model="profesor.nombre"
            style="border-radius: 10px;" :rules="[rules.nombre.required]"
            prepend-inner-icon="mdi-format-text" outlined
            color="white"
          />

          <v-text-field
            name="Profesor-text" label="Apellido" v-model="profesor.apellidos"
            style="border-radius: 10px;" :rules="[rules.apellido.required]"
            prepend-inner-icon="mdi-format-text" outlined
            color="white"
          />

          <v-select
            v-model="profesor.genero" :items="generos" item-value="valor"
            item-text="texto" style="border-radius: 10px;"
            prepend-inner-icon="mdi-gender-male" label="Género"
            :rules="[rules.genero.required]" outlined
            color="white"
          />

          <v-btn
            color="amber darken-2" light block style="border-radius: 10px;"
            elevation="0" x-large @click="ActualizarProfesor"
            dark v-if="profesor.idProfesor > 0"
          >
            <v-icon left dark size="25"> mdi-check </v-icon>
            Actualizar Profesor
          </v-btn>

          <v-btn
            color="blue darken-1" light block style="border-radius: 10px;"
            elevation="0" x-large @click="GuardarProfesor"
            dark v-else
          >
            <v-icon left dark size="25"> mdi-check </v-icon>
            Guardar Profesor
          </v-btn>

        </v-form>

      </v-card-text>

    </v-card>

  </v-dialog>

</template>

<script>

export default {

  props: {
    value: Boolean,
    profesor: Object
  },

  computed: {

    dialogo: {

      get(){
        return this.value
      },
      set(value){
        this.$emit('input', value)
      }

    }

  },

  data(){

    return {

      menu: false,

      generos: [
        { texto: "Masculino", valor: "M" },
        { texto: "Femenino", valor: "F" }
      ],

      rules: {

        nombre: { required: v => !!v || "El nombre es obligatorio" },

        apellido: { required: v => !!v || "El nombre es obligatorio" },

        genero: { required: v => !!v || "El género es obligatorio" }

      }

    }

  },

  methods: {

    async GuardarProfesor(){

      let config = { timeout: 5000 }

      await this.$axios.post("/profesores", this.profesor, config).then(({data}) => {

        this.$emit("refresh");
        this.CerrarDialogo()

      })

    },

    async ActualizarProfesor(){

      let config = { timeout: 5000 }

      await this.$axios.post("/profesores/" + this.profesor.idProfesor, this.profesor, config).then(({data}) => {

        this.$emit("refresh");
        this.CerrarDialogo()

      })

    },

    CerrarDialogo(){

      this.$emit("update:profesor", {})
      this.$refs.frmProfesor?.resetValidation()
      this.dialogo = false

    }

  }


}

</script>
